(function () {
  var table = document.getElementById('ttable')
  var input = document.getElementById('search')
  var clear = document.getElementById('search-clear')
  var audio = document.getElementById('player')
  var playing = document.getElementById('playing')
  var optdrop = document.getElementById('options-drop')
  var optmenu = document.getElementById('options')
  var loggedin = document.getElementById('logged-in')
  var trackedit = document.getElementById('track-edit-modal')
  var trackform = document.getElementById('track-set')
  var trackclose = document.getElementById('track-edit-close')

  var menu = document.getElementById('menu')

  var tableHead = '<tr> \
    <th data-sort-by="id" class="small">#</th> \
    <th data-sort-by="title">Track</th> \
    <th data-sort-by="artist">Artist</th> \
    <th data-sort-by="album">Album</th> \
    <th data-sort-by="year" class="small">Year</th> \
    <th class="small">Duration</th> \
  </tr>'

  var editing = null
  var nowPlaying = 0
  var externalStream = false

  var pageNum = 0
  var pages = 1
  var paginator = document.querySelector('.pages')
  var pageNumText = document.querySelector('.pages #pagenum')

  // Search saves
  var searching = false
  var pagePrev = 0
  var pagesPrev = 0

  // Queueing
  var queue = []
  var qTag = document.getElementById('queue')

  // Playlists
  var playlist = null
  var playlistCache = {}
  var playingList = null
  var pSel = document.getElementById('playlist-select')
  var dropdownBtn = pSel.querySelector('.dropdown-button')
  var ctxPlaylist = document.getElementById('ctx-playlists')

  // Options
  var optcont = document.querySelector('.sidebar.bar')
  var options = {
    autoplay: true,
    trackids: true,
    streamable: true,
    scrobble: false,
    sortby: 'id',
    sortdir: 'asc'
  }

  // User info
  var user = {}
  var scrobbleTimeout

  window.mobilecheck = function() {
    var check = false;
    (function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
    return check
  }
  window.isMobile = window.mobilecheck()

  // Context bullshit
  let playerContext = []

  window.resumeAudioContexts = function () {
    for (let i in playerContext) {
      let ctx = playerContext[i]
      if (ctx && ctx.resume) {
        ctx.resume().catch(function (e) {
          console.error(e)
          alert('Failed to play:', e.message)
        })
      }
    }
  }

  window.attachAudioContext = function (ctx) {
    playerContext.push(ctx)
  }

  // Seconds into HH:MM:SS
  function toHHMMSS (numbr) {
    let secNum = parseInt(numbr, 10) // don't forget the second param
    let hours = Math.floor(secNum / 3600)
    let minutes = Math.floor((secNum - (hours * 3600)) / 60)
    let seconds = secNum - (hours * 3600) - (minutes * 60)

    if (hours < 10) hours = '0' + hours
    if (minutes < 10) minutes = '0' + minutes
    if (seconds < 10) seconds = '0' + seconds

    let time = ''
    if (parseInt(hours) > 0) {
      time = hours + ':' + minutes + ':' + seconds
    } else {
      time = minutes + ':' + seconds
    }
    return time
  }

  function elementsToArray (elms) {
    let array = []
    for (let i in elms) {
      let el = elms[i]
      if (!(el instanceof Element)) continue
      array.push(el)
    }
    return array
  }

  function _httpRequest (method, url, data) {
    return new Promise(function (resolve, reject) {
      var xmlHttp = new XMLHttpRequest()
      xmlHttp.onreadystatechange = function () {
        if (xmlHttp.readyState === 4 && xmlHttp.status === 200) {
          resolve(JSON.parse(xmlHttp.responseText))
        } else if (xmlHttp.readyState === 4) {
          let msg = 'Server returned code ' + xmlHttp.status
          try {
            let ct = JSON.parse(xmlHttp.responseText)
            if (ct.error) msg = ct.error
          } catch (e) {}
          reject(new Error(msg))
        }
      }
      xmlHttp.withCredentials = true
      xmlHttp.open(method, url, true)
      if (method !== 'GET' && method !== 'HEAD') {
        xmlHttp.setRequestHeader('Content-Type', 'application/json;charset=UTF-8')
      }
      xmlHttp.send(data ? JSON.stringify(data) : null)
    })
  }

  function httpGet (url) {
    return _httpRequest('GET', url)
  }

  function httpPost (url, data) {
    return _httpRequest('POST', url, data)
  }

  function shortTitle (title, artist) {
    if (!artist) return title
    return artist + ' - ' + title
  }

  function handleHash () {
    let hash = window.location.hash
    if (hash.indexOf('#') === 0) hash = hash.substr(1)
    if (hash.length === 0) return

    window.location.hash = ''

    if (hash.indexOf('track-') === 0) {
      let trackNr = parseInt(hash.substr(6))
      if (!isNaN(trackNr)) return play(trackNr)
    }
  }

  function clickInsideElement (e, className) {
    var el = e.srcElement || e.target

    if (el.classList.contains(className)) {
      return el
    } else {
      while (el = el.parentNode) {
        if (el.classList && el.classList.contains(className)) {
          return el
        }
      }
    }

    return false
  }

  function getPosition(e) {
    var posx = 0
    var posy = 0

    if (!e) var e = window.event

    if (e.pageX || e.pageY) {
      posx = e.pageX
      posy = e.pageY
    } else if (e.clientX || e.clientY) {
      posx = e.clientX + document.body.scrollLeft + 
                         document.documentElement.scrollLeft
      posy = e.clientY + document.body.scrollTop + 
                         document.documentElement.scrollTop
    }

    return {
      x: posx,
      y: posy
    }
  }

  function positionMenu(e) {
    clickCoords = getPosition(e)
    clickCoordsX = clickCoords.x
    clickCoordsY = clickCoords.y

    menuWidth = menu.offsetWidth + 4
    menuHeight = menu.offsetHeight + 4

    windowWidth = window.innerWidth
    windowHeight = window.innerHeight

    if ( (windowWidth - clickCoordsX) < menuWidth ) {
      menu.style.left = windowWidth - menuWidth + 'px'
    } else {
      menu.style.left = clickCoordsX + 'px'
    }

    if ( (windowHeight - clickCoordsY) < menuHeight ) {
      menu.style.top = windowHeight - menuHeight + 'px'
    } else {
      menu.style.top = clickCoordsY + 'px'
    }
  }

  function removeFromQueue (id) {
    var index = queue.indexOf(id)
    if (index > -1) {
      queue.splice(index, 1)
    }
  }

  var ctxState = 0
  function ctxHide () {
    ctxState = 0
    menu.style.display = 'none'
  }

  function updateQT (q) {
    if (playlist === -1) showTracks(pageNum)
    if (q) {
      qTag.style.display = 'block'
      var cnt = '+' + queue.length
      if (queue.length === 0) cnt = '%'
      qTag.innerHTML = 'Queue ' + cnt
      return
    }
    qTag.style.display = 'none'
  }

  function removeFromPlaylist(track) {
    if (playlist == null || playlist < 0) return
    httpPost('/api/playlist/track/remove/' + playlist + '/' + track).then(function () {
      alert('Track removed from playlist successfully!')
      showPlaylist(playlist, true)
    }).catch(function (e) {
      alert(e.message)
    })
  }

  function addToPlaylist (playlistId, trackId) {
    httpPost('/api/playlist/track/put/' + playlistId + '/' + trackId).then(function () {
      alert('Track added to playlist successfully!')
      showPlaylist(playlistId, true)
    }).catch(function (e) {
      alert(e.message)
    })
  }

  function closeTrackModal () {
    editing = null
    trackedit.style.display = 'none'
  }

  function editTrack (tid) {
    httpGet('/api/track/' + tid).then(function (metadata) {
      editing = tid
      for (let i in metadata) {
        let el = trackform.querySelector('#ts-' + i)
        if (!el) continue
        el.value = metadata[i]
      }
      trackedit.style.display = 'block'
    }, function (e) {
      console.log(e)
    })
  }

  function ctxHandle (el) {
    if (ctxState === 0) return
    let dt = el.getAttribute("data-action")
    switch (dt) {
      case 'play':
        play(ctxState)
        break
      case 'queue':
        if (playlist === -1)
          removeFromQueue(ctxState)
        else
          queue.push(ctxState)
        break
      case 'download':
        window.open('/api/serve/by-id/' + ctxState + '?dl=1', '_blank')
        break
      case 'edit':
        editTrack(ctxState)
        break
      case 'playlist-remove':
        removeFromPlaylist(ctxState)
        break
      case 'playlist-new':
        createPlaylist(ctxState)
        break
    }
    // Adding to playlist
    if (dt && dt.indexOf('push-') === 0) {
      let id = dt.substr(5)
      addToPlaylist(id, ctxState)
    }
    ctxHide()
    updateQT(qTag.style.display === 'block')
  }

  function ctxTrack (xid, ev, qe) {
    positionMenu(ev)
    menu.style.display = 'block'

    let qbtn = menu.querySelector('.ctx-item[data-action="queue"]')
    qbtn.innerHTML = qe ? 'Remove from Queue' : 'Queue Track'

    let plAdd = menu.querySelector('.playlist-add')
    plAdd.style.display = isNaN(parseInt(xid)) ? 'none' : 'block'

    let tEdit = menu.querySelector('.ctx-item[data-action="edit"]')
    tEdit.style.display = isNaN(parseInt(xid)) ? 'none' : 'block'

    let plDel = menu.querySelector('.ctx-item[data-action="playlist-remove"]')
    plDel.style.display = (playlist != null && playlist >= 0) ? 'block' : 'none'

    ctxState = xid
  }

  function trackDataRow (track) {
    let title = window.isMobile ? shortTitle(track.title, track.artist) : track.title
    let trTag = document.createElement('tr')
    trTag.className = 'track'
    trTag.setAttribute('data-id', track.id)
    if (track.external) trTag.className += ' external'
    trTag.innerHTML += '<td>' + (track.external ? 'Stream' : (options.trackids ? track.id : (track.track || '&nbsp;'))) + '</td>'
    trTag.innerHTML += '<td>' + title + '</td>'
    trTag.innerHTML += '<td>' + (track.artist || '') + '</td>'
    trTag.innerHTML += '<td>' + (track.album || '') + '</td>'
    trTag.innerHTML += '<td>' + (track.year || '') + '</td>'
    trTag.innerHTML += '<td>' + (track.duration ? toHHMMSS(track.duration) : '') + '</td>'
    return trTag
  }

  function handleHeads () {
    if (playlist === -1) return
    let els = elementsToArray(document.querySelectorAll('th'))
    let sortarr = document.createElement('span')
    sortarr.className = 'order' + (options.sortdir === 'desc' ? ' dn' : '')
    for (let i in els) {
      let head = els[i]
      let sortattr = head.getAttribute('data-sort-by')
      if (!sortattr || sortattr === '') continue
      if (sortattr === options.sortby) {
        head.appendChild(sortarr)
      }

      head.addEventListener('click', function (e) {
        if (options.sortby !== sortattr) {
          options.sortdir = 'asc'
          options.sortby = sortattr
          if (playlist == null || playlist < 0) return showTracks(pageNum)
          showPlaylist(playlist)
        }

        options.sortdir = (options.sortdir === 'asc' ? 'desc' : 'asc')
        if (playlist == null || playlist < 0) return showTracks(pageNum)
        showPlaylist(playlist)
      })
    }
  }

  function constructList (tracks) {
    table.innerHTML = tableHead

    for (let i in tracks) {
      let track = tracks[i]
      let tag = trackDataRow(track)

      tag.addEventListener('click', function (e) {
        play.call(this, track.trackId || track.id)
      }, false)

      tag.addEventListener('contextmenu', function (e) {
        e.preventDefault()
        ctxTrack(track.trackId || track.id, e)
      }, false)

      table.appendChild(tag)
    }

    handleHeads()
  }

  function recursionQueueList (index) {
    let qid = queue[index]
    if (!qid || playlist !== -1) return

    httpGet('/api/track/' + qid).then(function (data) {
      let tag = trackDataRow(data)

      tag.addEventListener('contextmenu', function (e) {
        e.preventDefault()
        ctxTrack(qid, e, true)
      }, false)

      table.appendChild(tag)

      recursionQueueList(index + 1)
    }, function (e) {
      console.log(e)
    })
  }

  function constructQueue () {
    table.innerHTML = tableHead
    recursionQueueList(0)
  }

  function updatePaging () {
    if (pages > 1) {
      paginator.style.display = 'flex'
    } else {
      paginator.style.display = 'none'
      return
    }

    pageNumText.innerHTML = pageNum + ' / ' + pages
  }

  function populatePlaylists () {
    // Remove existing playlist names from the dropdown
    let elems = elementsToArray(pSel.querySelectorAll('.playlist'))
    for (let i in elems) {
      let element = elems[i]
      element.parentNode.removeChild(element)
    }

    // Get user playlists and add them to the dropdown
    httpGet('/api/playlist').then(function (content) {
      ctxPlaylist.innerHTML = ''
      for (let i in content) {
        let plylit = content[i]
        // Add selection
        let elem = document.createElement('div')
        elem.className = 'playlist'
        elem.innerHTML = plylit.title
        elem.setAttribute('data-value', plylit.id)
        pSel.querySelector('.dropdown-content').appendChild(elem)
        // Add CTX clues
        let li = document.createElement('li')
        let ctxItem = document.createElement('div')
        ctxItem.className = 'ctx-item'
        ctxItem.innerHTML = plylit.title
        ctxItem.setAttribute('data-action', 'push-' + plylit.id)
        li.appendChild(ctxItem)
        ctxPlaylist.appendChild(li)
      }

      let lit = document.createElement('li')
      let ctxItemGeneral = document.createElement('div')
      ctxItemGeneral.className = 'ctx-item'
      ctxItemGeneral.innerHTML = 'New..'
      ctxItemGeneral.setAttribute('data-action', 'playlist-new')
      lit.appendChild(ctxItemGeneral)
      ctxPlaylist.appendChild(lit)

      handleSelect()
    })
  }

  function showPlaylist (pid, updateOnly) {
    if (!(updateOnly && playlist !== pid)) {
      playlist = pid
      pages = 1
      pageNum = 1
    }
    httpGet('/api/playlist/' + pid + '?page=' + pageNum + '&sort=' + options.sortby + '&sortdir=' + options.sortdir).then(function (content) {
      playlistCache[content.id] = content
      if (!(updateOnly && playlist !== pid)) {
        constructList(content.tracks)
        updatePaging()
      }
    })
  }

  function createPlaylist (toAdd) {
    let title = window.prompt('Enter name for playlist')
    if (!title || title === '') return
    httpPost('/api/playlist/new', { title: title }).then(function (d) {
      if (toAdd == null) alert('Playlist created successfully!')
      populatePlaylists()
      if (toAdd != null) {
        addToPlaylist(d.playlist, toAdd)
      }
    }).catch(function (e) {
      alert(e.message)
    })
  }

  function showTracks (page) {
    let query = input.value
    if (searching && query.trim() === '') {
      searching = false
      pagePrev = 0
      pages = pagesPrev
      clear.style.display = 'none'
    }

    if (page > pages) page = pages
    updatePaging()

    if (playlist === -1) {
      return constructQueue()
    }

    playlist = null
    dropdownBtn.innerHTML = 'All Tracks'

    if (query.trim() === '') {
      return httpGet('/api/tracks?page=' + page + '&sort=' + options.sortby + '&sortdir=' + options.sortdir).then(function (data) {
        pageNum = page
        pages = data.pageCount
        constructList(data.tracks)
        updatePaging()
      })
    }

    if (!searching) {
      pagePrev = pageNum
      pagesPrev = pages
      searching = true
      clear.style.display = 'block'
    }

    httpGet('/api/tracks/search?q=' + query + '&page=' + page + '&sort=' + options.sortby + '&sortdir=' +
      options.sortdir + '&streamable=' + (+options.streamable)).then(function (data) {
      pageNum = page
      pages = data.pageCount
      constructList(data.tracks)
      updatePaging()
    })
  }

  function scrobblePlaying (track) {
    if (!user.lastfm || !user.lastfm.connected || !options.scrobble) return
    if (scrobbleTimeout) clearTimeout(scrobbleTimeout)
    // Scrobble the track after 10 seconds of playing
    // Prevents scrobbling tracks that are not listened for long
    scrobbleTimeout = setTimeout(function () {
      if (audio.paused) return
      httpPost('/api/lastfm/scrobble/' + track).catch(function (e) {
        console.warn('Scrobbling failed:', e.message)
      })
    }, 10000)
  }

  function play (id, q, fromNext) {
    if (id < 1) return playNext()
    httpGet('/api/track/' + id).then(function (data) {
      let title = shortTitle(data.title, data.artist)
      playing.innerHTML = title
      document.title = title

      window.resumeAudioContexts()

      externalStream = (data.external === true)
      audio.src = data.play_url || ('/api/serve/by-id/' + id)
      audio.play()

      updateQT(q)

      scrobblePlaying(id)
      nowPlaying = id
      if (!fromNext) {
        if (playlist != null && playlist > -1 && !q) {
          playingList = playlist
        } else {
          playingList = null
        }
      }
    }, function (e) {
      console.log(e)
    })
  }

  function playPrevious () {
    if (playingList) {
      let pl = playlistCache[playingList]
      if (pl) {
        let prevTrack = null
        for (let i in pl.tracks) {
          let tr = pl.tracks[i]
          if (tr.trackId === nowPlaying) {
            prevTrack = parseInt(i) - 1
            break
          }
        }
        if (prevTrack == null || !pl.tracks[prevTrack]) return
        return play(pl.tracks[prevTrack].trackId, false, true)
      }
    }
    if (externalStream) return
    play(nowPlaying - 1, false, true)
  }

  function playNext () {
    if (queue.length !== 0) return play(queue.shift(), true, true)
    if (playingList) {
      let pl = playlistCache[playingList]
      if (pl) {
        let nextTrack = null
        for (let i in pl.tracks) {
          let tr = pl.tracks[i]
          if (tr.trackId === nowPlaying) {
            nextTrack = parseInt(i) + 1
            break
          }
        }
        if (nextTrack == null || !pl.tracks[nextTrack]) return
        return play(pl.tracks[nextTrack].trackId, false, true)
      }
    }
    if (externalStream) return
    play(nowPlaying + 1, false, true)
  }

  var ignoreFirst = false
  function toggleOptions () {
    if (optdrop.className.indexOf('active') !== -1) {
      optdrop.className = 'sidebar background'
    } else {
      optdrop.className = 'sidebar background active'
      ignoreFirst = true
    }
  }

  function handleSelect () {
    let btns = elementsToArray(pSel.querySelectorAll('.dropdown-content div'))

    for (let i in btns) {
      let btni = btns[i]
      let cnt = btni.getAttribute('data-value')
      if (btni.getAttribute('data-bound')) continue

      btni.addEventListener('click', function (e) {
        let isPlaylist = false
        let last = dropdownBtn.innerHTML
        let set = btni.innerHTML
        switch (cnt) {
          case 'all':
            playlist = null
            break
          case 'queue':
            playlist = -1
            break
          case 'options':
            toggleOptions()
            set = last
            break
          default:
            isPlaylist = true
            showPlaylist(cnt)
        }
        dropdownBtn.innerHTML = set
        if (!isPlaylist) showTracks(pageNum)
      }, false)

      btni.setAttribute('data-bound', true)
    }
  }

  function saveOptions () {
    if (!window.localStorage) return
    let itms = JSON.stringify(options)
    window.localStorage.setItem('options', itms)
  }

  function loadOptions () {
    if (!window.localStorage) return
    let itms = window.localStorage.getItem('options')
    if (!itms || itms === '') return
    let obj = {}
    try {
      obj = JSON.parse(itms)
    } catch (e) {}
    options = Object.assign({}, options, obj)
  }

  function handleOptions () {
    let elms = elementsToArray(optmenu.querySelectorAll('input'))
    elms = elms.concat(elementsToArray(optmenu.querySelectorAll('select')))
    for (let i in elms) {
      let inpt = elms[i]
      if (!(inpt instanceof Element)) continue
      let opt = inpt.getAttribute('name')
      let type = inpt.getAttribute('type')

      if (type == 'checkbox') {
        inpt.checked = options[opt]
        inpt.addEventListener('change', function (event) {
          options[opt] = event.target.checked
          showTracks(pageNum)
          saveOptions()
        })
      } else {
        inpt.value = options[opt]
        inpt.addEventListener('change', function (event) {
          options[opt] = event.target.value
          showTracks(pageNum)
          saveOptions()
        })
      }
    }
  }

  function updateLastFMOptions () {
    let lfmconnect = document.getElementById('lfm-connect')
    let lfmconnected = document.getElementById('lfm-connected')
    let lfmdisconnect = document.getElementById('lfm-disconnect')
    let lfmscrobble = document.getElementById('lfm-scrobble')
    if (user.lastfm && user.lastfm.connected) {
      let lfm = user.lastfm.name
      let url = '<a href="https://www.last.fm/user/' + lfm + '" target="_blank">' + lfm + '</a>'
      lfmconnect.style.display = 'none'
      lfmscrobble.style.display = 'block'
      lfmconnected.innerHTML = 'Connected (' + url + ')'
    } else {
      lfmconnect.style.display = 'block'
      lfmdisconnect.style.display = 'none'
      lfmscrobble.style.display = 'none'
    }
  }

  input.addEventListener('keyup', function (e) {
    e.which === 13 && showTracks(input.value.trim() === '' ? (pagePrev !== 0 ? pagePrev : 1) : 1)
  }, false)

  audio.addEventListener('ended', function (e) {
    if (externalStream) return
    if (!options.autoplay) return
    playNext(e)
  }, false)

  clear.addEventListener('click', function () {
    input.value = ''
    showTracks(pagePrev !== 0 ? pagePrev : 1)
  })

  var metas = ['title', 'artist', 'album', 'year', 'genre', 'track']
  trackform.addEventListener('submit', function (e) {
    e.preventDefault()
    if (editing == null) return closeTrackModal()

    let meta = {}

    for (let k in metas) {
      let p = metas[k]
      let a = trackedit.querySelector('#ts-' + p)
      if (!a) continue
      meta[p] = a.value
    }

    httpPost('/api/track/' + editing, meta).then(function () {
      closeTrackModal()
      alert('Successfully edited track metadata!')
      if (!playlist || playlist < 0) showTracks(pageNum)
      else showPlaylist(playlist)
    }).catch(function (e) {
      alert(e.message)
      console.error(e)
    })
  }, false)

  trackclose.addEventListener('click', closeTrackModal, false)

  document.getElementById('player-next').addEventListener('click', playNext, false)

  document.getElementById('player-prev').addEventListener('click', playPrevious, false)

  document.getElementById('jump-first').addEventListener('click', function (e) {
    showTracks(1)
  }, false)

  document.getElementById('jump-prev').addEventListener('click', function (e) {
    if (pageNum <= 1) return
    showTracks(pageNum - 1)
  }, false)

  document.getElementById('jump-next').addEventListener('click', function (e) {
    showTracks(pageNum + 1)
  }, false)

  document.getElementById('jump-last').addEventListener('click', function (e) {
    showTracks(pages)
  }, false)

  window.addEventListener('hashchange', function (e) {
    e.preventDefault()
    handleHash()
  }, false)

  window.addEventListener('resize', function (e) {
    ctxHide()
  }, false)

  document.addEventListener('click', function(e) {
    var clickeElIsLink = clickInsideElement(e, 'ctx-item')

    if (clickeElIsLink) {
      e.preventDefault()
      ctxHandle(clickeElIsLink)
    } else {
      var button = e.which || e.button
      if ( button === 1 ) {
        ctxHide()
      }
    }
  })

  document.addEventListener('click', function (event) {
    // event.target.closest(optcont) === null
    if (!optcont.contains(event.target) && optdrop.className.indexOf('active') !== -1) {
      if (ignoreFirst) {
        ignoreFirst = false
        return
      }
      toggleOptions()
    }
  })

  function checkUser () {
    httpGet('/user/info').then(function (data) {
      user = data
      loggedin.innerHTML = 'Logged in as ' + data.username
      // Last.fm
      httpGet('/api/lastfm').then(function (data) {
        user.lastfm = data
        updateLastFMOptions()
      })
    }, function (e) {
      window.location.href = '/user/login'
    })
  }

  checkUser()
  loadOptions()
  showTracks(1)
  handleHash()
  populatePlaylists()
  handleSelect()
  handleOptions()
})()
